# by Defiant <mail@defiant.homedns.org>
# Distance() is written by Banbury in his QBR

import App
import MissionLib
import Bridge.BridgeUtils
import QuickBattle.QuickBattle
import AI.Player.InterceptTarget
import AI.Compound.FollowThroughWarp
import string
import Lib.LibEngineering

pBridge = App.g_kSetManager.GetSet('bridge')
g_pKiska = App.CharacterClass_GetObject(pBridge, 'Helm')
pKiskaMenu = Bridge.BridgeUtils.GetBridgeMenu('Helm')

NEW_NAV_POINT = Lib.LibEngineering.GetEngineeringNextEventType()
FOLLOW_WAYPOINTS = Lib.LibEngineering.GetEngineeringNextEventType()
NAV_POINT_TIMER = Lib.LibEngineering.GetEngineeringNextEventType()
STOP_FOLLOW = Lib.LibEngineering.GetEngineeringNextEventType()
REMOVE_WAYPOINT = Lib.LibEngineering.GetEngineeringNextEventType()
GET_CURRENT_WAYPOINT = Lib.LibEngineering.GetEngineeringNextEventType()

WayPointNuber = 0
Do_follow = 0
pNavPointSave = None

MODINFO = { "Author": "\"Defiant\" mail@defiant.homedns.org",
            "Download": "http://defiant.homedns.org/~erik/STBC/NavPoints/",
            "Version": "0.2",
            "License": "GPL",
            "Description": "Create Custom Navpoints"
            }

def NewWayPoint(pObject, pEvent):
    global WayPointNuber
    
    # pre stuff - Variables we need etc.
    WayPointNuber = WayPointNuber + 1
    pPlayer = MissionLib.GetPlayer()
    SetName = pPlayer.GetContainingSet().GetName()
    PlayerXpos = pPlayer.GetWorldLocation().GetX()
    PlayerYpos = pPlayer.GetWorldLocation().GetY()
    PlayerZpos = pPlayer.GetWorldLocation().GetZ()

    # Create the waypoint
    kThis = App.Waypoint_Create("Custom Waypoint " + str(WayPointNuber), SetName, None)
    kThis.SetStatic(0)
    kThis.SetNavPoint(1)
    kThis.SetTranslateXYZ(PlayerXpos, PlayerYpos, PlayerZpos)


# If the Nav point is in the same Set as the Player
def NavPointInSameSet(pNavPointSave):
    pPlayer = MissionLib.GetPlayer()
    pSet = pPlayer.GetContainingSet()
    SetNavPoints = pSet.GetNavPoints()
    
    for pNavPoint in SetNavPoints:
        if (pNavPoint.GetName() == pNavPointSave.GetName()):
                return 1
    return 0


# puh, this won't be easy
def followWaypoints(pObject=None, pEvent=None):
    # ok lets start it easy: Get the vars we could need
    global pNavPointSave, Do_follow
    pPlayer = MissionLib.GetPlayer()
    usethis  = 0
    SetNavPoints = None
    
    if pEvent:
        Do_follow = 1

    # now, lets try to get all navpoints first...uff never have done this before *hope it works*
    for pSet in App.g_kSetManager.GetAllSets():
        if not SetNavPoints:
            SetNavPoints = pSet.GetNavPoints()
        else:
            SetNavPoints = SetNavPoints + pSet.GetNavPoints()
        
    curNavP = 1
    for pNavPoint in SetNavPoints:
        if not pNavPointSave:
            break
        if (pNavPoint.GetName() == pNavPointSave.GetName()):
            break
        curNavP = curNavP + 1
    
    # count or nav points
    cWP = 0
    for pNavPoint in SetNavPoints:
        # only use our waypoints plz
        if (string.find(pNavPoint.GetName(), "Custom Waypoint") != -1):
                cWP = cWP + 1
    if (cWP < 2):
        print("Not enough Waypoints")
        return
    
    for pNavPoint in SetNavPoints:
        # only use our waypoints plz
        if (string.find(pNavPoint.GetName(), "Custom Waypoint") == -1):
                continue
        if (curNavP == len(SetNavPoints) or not pNavPointSave):
            usethis = 1
        elif (pNavPoint.GetName() == pNavPointSave.GetName()):
            # then use next one
            usethis = 1
            continue
        if usethis:
            pNavPointSave = pNavPoint
            if NavPointInSameSet(pNavPointSave):
                MissionLib.SetPlayerAI("Helm", AI.Player.InterceptTarget.CreateAI(pPlayer, pNavPointSave))
            else:
                MissionLib.SetPlayerAI("Helm", AI.Compound.FollowThroughWarp.CreateAI(pPlayer, pNavPointSave.GetName()))
            break
    CheckReachWaypoint()


# Timer if we reached our WP
def CheckReachWaypoint(pObject=None, pEvent=None):
    global NAV_POINT_TIMER, pNavPointSave, Do_follow

    if (Do_follow == 0):
        return

    pPlayer = MissionLib.GetPlayer()
    if not pNavPointSave:
        return
    
    if (Distance(pNavPointSave) < 30):
        followWaypoints()
        return
    if not pPlayer.GetImpulse(): # Argh - no speed? reset PlayerAI!
        if NavPointInSameSet(pNavPointSave):
            MissionLib.SetPlayerAI("Helm", AI.Player.InterceptTarget.CreateAI(pPlayer, pNavPointSave))
        else:
            MissionLib.SetPlayerAI("Helm", AI.Compound.FollowThroughWarp.CreateAI(pPlayer, pNavPointSave.GetName()))
    # Create an event - it's a thing that will call this function
    pTimerEvent = App.TGEvent_Create()
    pTimerEvent.SetEventType(NAV_POINT_TIMER)
    pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())

    # Create a timer - it's a thing that will wait for a given time,then do something
    pTimer = App.TGTimer_Create()
    pTimer.SetTimerStart(App.g_kUtopiaModule.GetGameTime() + 20) # check every 20 seconds
    pTimer.SetDelay(0)
    pTimer.SetDuration(0)
    pTimer.SetEvent(pTimerEvent)
    App.g_kTimerManager.AddTimer(pTimer)


# Distance() by Banbury
def Distance(pObject):
	pPlayer = App.Game_GetCurrentGame().GetPlayer()
	vDifference = pObject.GetWorldLocation()
	vDifference.Subtract(pPlayer.GetWorldLocation())

	return vDifference.Length()


# Stop it
def Stopfollow(pObject=None, pEvent=None):
    global Do_follow
    pPlayer = MissionLib.GetPlayer()
    
    Do_follow = 0
    MissionLib.SetPlayerAI("Captain", None)
    pPlayer.ClearAI()


# Removes a waypoint
def RemoveWaypoint(pObject, pEvent):
    global pNavPointSave
    pPlayer = MissionLib.GetPlayer()
    pSet = pPlayer.GetContainingSet()
    pTarget = pPlayer.GetTarget()
    
    if not pPlayer or not pSet:
        return
    
    MissionLib.RemoveNavPoints(pSet.GetName(), pTarget.GetName())
    pNavPointSave = None
    Stopfollow()


# Targets the current waypoint
def GetCurrentWaypoint(pObject, pEvent):
    global pNavPointSave
    
    pPlayer = MissionLib.GetPlayer()
    if pNavPointSave:
        pPlayer.SetTarget(pNavPointSave.GetName())


def init():
    # Buttons
    pMasterButtonNav = App.STMenu_CreateW(App.TGString("Navpoint control"))
    pKiskaMenu.PrependChild(pMasterButtonNav)
            
    g_pKiska.AddPythonFuncHandlerForInstance(NEW_NAV_POINT, __name__ + ".NewWayPoint")
    g_pKiska.AddPythonFuncHandlerForInstance(FOLLOW_WAYPOINTS, __name__ + ".followWaypoints")
    g_pKiska.AddPythonFuncHandlerForInstance(STOP_FOLLOW, __name__ + ".Stopfollow")
    g_pKiska.AddPythonFuncHandlerForInstance(REMOVE_WAYPOINT, __name__ + ".RemoveWaypoint")
    g_pKiska.AddPythonFuncHandlerForInstance(GET_CURRENT_WAYPOINT, __name__ + ".GetCurrentWaypoint")

    pButtonSetWayPoint = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Set Navpoint'), NEW_NAV_POINT, 0, g_pKiska)
    pButtonFollowWaypoints = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Follow waypoints'), FOLLOW_WAYPOINTS, 0, g_pKiska)
    pButtonFollowStop = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Stop following'), STOP_FOLLOW, 0, g_pKiska)
    pButtonRemoveWP = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Remove Waypoint'), REMOVE_WAYPOINT, 0, g_pKiska)
    pButtonGetCurrentWP = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Get Current'), GET_CURRENT_WAYPOINT, 0, g_pKiska)

    pMasterButtonNav.PrependChild(pButtonSetWayPoint)
    pMasterButtonNav.PrependChild(pButtonFollowWaypoints)
    pMasterButtonNav.PrependChild(pButtonFollowStop)
    pMasterButtonNav.PrependChild(pButtonRemoveWP)
    pMasterButtonNav.PrependChild(pButtonGetCurrentWP)

    # Timer
    App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(NAV_POINT_TIMER, __name__ + ".CheckReachWaypoint")
